VERSION 4.00
Begin VB.Form Form1 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   Caption         =   "Dave Grund's Date Calculator - Vers 1.0"
   ClientHeight    =   4515
   ClientLeft      =   1425
   ClientTop       =   1905
   ClientWidth     =   7365
   BeginProperty Font 
      name            =   "MS Sans Serif"
      charset         =   0
      weight          =   700
      size            =   8.25
      underline       =   0   'False
      italic          =   0   'False
      strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4920
   Left            =   1365
   LinkTopic       =   "Form1"
   ScaleHeight     =   4515
   ScaleWidth      =   7365
   Top             =   1560
   Width           =   7485
   Begin VB.CommandButton btnAbout 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "About"
      Height          =   495
      Left            =   2640
      TabIndex        =   9
      Top             =   3720
      Width           =   1815
   End
   Begin VB.CommandButton btnExit 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Exit"
      Height          =   495
      Left            =   3840
      TabIndex        =   5
      Top             =   3000
      Width           =   1815
   End
   Begin VB.CommandButton btnCalculate 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Calculate"
      Default         =   -1  'True
      Height          =   495
      Left            =   1320
      TabIndex        =   4
      Top             =   3000
      Width           =   1815
   End
   Begin VB.TextBox txtToDate 
      Alignment       =   2  'Center
      BeginProperty Font 
         name            =   "Arial"
         charset         =   0
         weight          =   700
         size            =   15.75
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   600
      Left            =   3120
      MaxLength       =   10
      TabIndex        =   2
      Top             =   2160
      Width           =   2415
   End
   Begin VB.TextBox txtSpan 
      Alignment       =   2  'Center
      BeginProperty Font 
         name            =   "Arial"
         charset         =   0
         weight          =   700
         size            =   13.5
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   600
      Left            =   6000
      TabIndex        =   3
      Top             =   2160
      Width           =   1095
   End
   Begin VB.TextBox txtFromDate 
      Alignment       =   2  'Center
      BeginProperty Font 
         name            =   "Arial"
         charset         =   0
         weight          =   700
         size            =   15.75
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   600
      Left            =   240
      MaxLength       =   10
      TabIndex        =   1
      Top             =   2160
      Width           =   2415
   End
   Begin VB.Label Label4 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "To Date"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   3600
      TabIndex        =   6
      Top             =   1800
      Width           =   1455
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Span"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   6120
      TabIndex        =   7
      Top             =   1800
      Width           =   855
   End
   Begin VB.Label lblFromDate 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "From Date"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   720
      TabIndex        =   8
      Top             =   1800
      Width           =   1455
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Date Calculator"
      BeginProperty Font 
         name            =   "Black Chancery"
         charset         =   0
         weight          =   700
         size            =   39
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   855
      Left            =   840
      TabIndex        =   0
      Top             =   360
      Width           =   5415
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Private Sub btnAbout_Click()
    AboutStr = "About"
    About.Show Modal
End Sub

Private Sub btnCalculate_Click()
    Dim FMM, FDD, FYY, TMM, TDD, TYY
    Dim FromDate, ToDate, Span, FromSerial, ToSerial
    Dim FieldMissingCount
    
    ' First see which field is missing. If none, then blank out Span
    FieldMissingCount = 0
    If txtFromDate = "" Then FieldMissingCount = FieldMissingCount + 1
    If txtToDate = "" Then FieldMissingCount = FieldMissingCount + 1
    If txtSpan = "" Then FieldMissingCount = FieldMissingCount + 1
    If FieldMissingCount = 0 Then txtSpan = ""
    If FieldMissingCount > 1 Then
        MsgBox "Too many fields missing!", 48, "You blew it!"
        Exit Sub
    End If

    If txtFromDate = "" Then
      ToDate = Format(txtToDate, "mm/dd/yyyy")
      TMM = Left(ToDate, 2)      ' Get month number.
      TDD = Mid(ToDate, 4, 2)    ' Get day number
      TYY = Right(ToDate, 4)     ' Get year number.
      On Error GoTo ToError
      ToSerial = DateSerial(TYY, TMM, TDD)
      On Error GoTo SpanError
      Span = txtSpan + 0
      On Error GoTo GeneralError
      FromSerial = ToSerial - Span
      txtFromDate = Format(FromSerial, "mm/dd/yyyy")
    End If

    If txtToDate = "" Then
      FromDate = Format(txtFromDate, "mm/dd/yyyy")
      FMM = Left(FromDate, 2)      ' Get month number.
      FDD = Mid(FromDate, 4, 2)    ' Get day number
      FYY = Right(FromDate, 4)     ' Get year number.
      On Error GoTo FromError
      FromSerial = DateSerial(FYY, FMM, FDD)
      On Error GoTo SpanError
      Span = txtSpan + 0
      On Error GoTo GeneralError
      ToSerial = FromSerial + Span
      txtToDate = Format(ToSerial, "mm/dd/yyyy")
    End If

    If txtSpan = "" Then
      FromDate = Format(txtFromDate, "mm/dd/yyyy")
      FMM = Left(FromDate, 2)      ' Get month number.
      FDD = Mid(FromDate, 4, 2)    ' Get day number
      FYY = Right(FromDate, 4)     ' Get year number.
      On Error GoTo FromError
      FromSerial = DateSerial(FYY, FMM, FDD)
      
      ToDate = Format(txtToDate, "mm/dd/yyyy")
      TMM = Left(ToDate, 2)      ' Get month number.
      TDD = Mid(ToDate, 4, 2)    ' Get day number
      TYY = Right(ToDate, 4)     ' Get year number.
      On Error GoTo ToError
      ToSerial = DateSerial(TYY, TMM, TDD)
      
      Span = ToSerial - FromSerial
      txtSpan = Span
    End If
Exit Sub

FromError:
    MsgBox "The From Date is in error", 48, "You blew it!"
Exit Sub

ToError:
    MsgBox "The To Date is in error", 48, "You blew it!"
Exit Sub

SpanError:
    MsgBox "The span that you entered is invalid"
Exit Sub

GeneralError:
    Beep
    Resume Next
End Sub


Private Sub btnExit_Click()
    End
End Sub

Private Sub Form_Load()
    txtFromDate = Format$(Int(Now), "mm/dd/yyyy")
    txtToDate = Format$(Int(Now), "mm/dd/yyyy")
    txtSpan = 0
End Sub

